package com.rlozano.tfc.actions.backend.usuarios;

import org.apache.struts2.convention.annotation.Action;
import org.apache.struts2.convention.annotation.Namespace;
import org.apache.struts2.convention.annotation.Result;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.rlozano.tfc.dao.UsuarioDAO;
import com.rlozano.tfc.interfaces.ConstatnsInterface;
import com.rlozano.tfc.models.Usuario;


@Namespace(value="/backend/usuarios")
@Action(value="insertar", results={
		@Result(location="/backend/usuarios", type="redirect", name="success"),
		@Result(location="/error.jsp", name="error")
})
public class InsertarUsuarioAction extends ActionSupport implements ConstatnsInterface{

	private static final long serialVersionUID = 673535456578947843L;
	
	private Usuario cliente;

	private String nombre;
	private String username;
	private String pass1;
	private String pass2;
	private String email;
	
	public String execute(){
		boolean logged = ActionContext.getContext().getSession().get(SESSION) != null;
		if(logged){
			String password = pass1.equals(pass2)? pass1: null;
			if(password == null)
				return ERROR;
			
			Usuario usuario = new Usuario();
			usuario.setNombre(nombre);
			usuario.setUsername(username);
			usuario.setPassword(password);
			usuario.setEmail(email);
		    UsuarioDAO.insertarUsuario(usuario);
		}
		return logged?SUCCESS:ERROR;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	

	public String getPass1() {
		return pass1;
	}

	public void setPass1(String pass1) {
		this.pass1 = pass1;
	}

	public String getPass2() {
		return pass2;
	}

	public void setPass2(String pass2) {
		this.pass2 = pass2;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}
	
	
	
	
}
