package com.rlozano.tfc.actions.frontend.clientes;

import org.apache.struts2.convention.annotation.Action;
import org.apache.struts2.convention.annotation.Namespace;
import org.apache.struts2.convention.annotation.Result;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.rlozano.tfc.dao.ClientesDAO;
import com.rlozano.tfc.interfaces.ConstatnsInterface;
import com.rlozano.tfc.models.Cliente;


@Namespace(value="/clientes")
@Action(value="guardar", results={
		@Result(location="/clientes", type="redirect", name="success"),
		@Result(location="/error.jsp", name="error")
})
public class GuardarClienteAction extends ActionSupport implements ConstatnsInterface{

	private static final long serialVersionUID = 673535456578947843L;
	
	private Cliente cliente;
    
	private Integer id;
	private String nombre;
	private String apellidos;
	private String telefono;
	private String email;
	private String direccion;
	private String municipio;
	private String provincia;
	private String cp;
	private String patologia;
	private String evolucion;
	
	public String execute(){
		boolean logged = ActionContext.getContext().getSession().get(SESSION) != null;
		if(logged){
			Cliente cl = new Cliente();
			cl.setId(id);
			cl.setNombre(nombre);
			cl.setApellidos(apellidos);
			cl.setEmail(email);
			cl.setTelefono(telefono);
			cl.setDireccion(direccion);
			cl.setMunicipio(municipio);
			cl.setCp(cp);
			cl.setProvincia(provincia);
			cl.setPatologia(patologia);
			cl.setEvolucion(evolucion);
		    ClientesDAO.guaradarCliente(cl);
		}
		return logged?SUCCESS:ERROR;
	}
	
	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getApellidos() {
		return apellidos;
	}

	public void setApellidos(String apellidos) {
		this.apellidos = apellidos;
	}

	public String getTelefono() {
		return telefono;
	}

	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getDireccion() {
		return direccion;
	}

	public void setDireccion(String direccion) {
		this.direccion = direccion;
	}

	public String getMunicipio() {
		return municipio;
	}

	public void setMunicipio(String municipio) {
		this.municipio = municipio;
	}

	public String getProvincia() {
		return provincia;
	}

	public void setProvincia(String provincia) {
		this.provincia = provincia;
	}

	public String getCp() {
		return cp;
	}

	public void setCp(String cp) {
		this.cp = cp;
	}

	public String getPatologia() {
		return patologia;
	}

	public void setPatologia(String patologia) {
		this.patologia = patologia;
	}

	public String getEvolucion() {
		return evolucion;
	}

	public void setEvolucion(String evolucion) {
		this.evolucion = evolucion;
	}
	
}
