package com.rlozano.tfc.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;

import com.rlozano.tfc.models.Cita;
import com.rlozano.tfc.models.Cliente;
import com.rlozano.tfc.persistence.Persistence;

public class CitasDAO {
	public static List<Cita> getCitas(){
		List<Cita> citas = new ArrayList<Cita>();
		
		Connection cn = null;
		PreparedStatement st = null;
		ResultSet rs = null;
		String query = "SELECT * FROM fisio_v_lista_citas";
		
		try{
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			rs = st.executeQuery();
			while(rs.next()){
				Cita cita = new Cita(
						rs.getInt("ID"), 
						rs.getString("nombre") + " | " +rs.getString("descripcion"), 
						rs.getTimestamp("fechaIni"), 
						rs.getTimestamp("fechaFin")
				);
				citas.add(cita);
			}
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		return citas;
	}
	
	public static Integer insertarCita(Cita cita, Integer idCliente){
		Connection cn = null;
		PreparedStatement st = null;
		Integer id = null;
		try{
			
			String query = "INSERT INTO fisio_t_citas (fechaIni, fechaFin, descripcion, id_cliente)"
					+ " VALUES (?, ?, ?, ?)";
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			int i = 1;
			st.setTimestamp(i++, new Timestamp(cita.getStart().getTime()));
			st.setTimestamp(i++, new Timestamp(cita.getEnd().getTime()));
			//st.setDate(i++, new java.sql.Date(cita.getStart().getTime()));
			//st.setDate(i++, new java.sql.Date(cita.getEnd().getTime()));
			st.setString(i++, cita.getTitle());
			st.setInt(i++, idCliente);
			st.executeUpdate();
			
			ResultSet rs = st.getGeneratedKeys();
			if(rs.next()){
				id=rs.getInt(1);
			}

			
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		return id;
	}
	
	public static void eliminarCita(Integer id){
		Connection cn = null;
		PreparedStatement st = null;
		try{
	
			String query = "DELETE FROM fisio_t_citas WHERE id = "+id;
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			int i = 1;
			
			st.addBatch(query);
			st.executeBatch();
			
			
			cn.close();
			
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
	}
}
