package com.rlozano.tfc.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.opensymphony.xwork2.ActionContext;
import com.rlozano.tfc.interfaces.ConstatnsInterface;
import com.rlozano.tfc.models.Cita;
import com.rlozano.tfc.models.Cliente;
import com.rlozano.tfc.persistence.Persistence;

public class ClientesDAO {
	public static List<Cliente> getListado(){
		Connection cn = null;
		PreparedStatement st = null;
		ResultSet rs = null;
		String query = "SELECT * FROM fisio_v_clientes"
				+ " WHERE id_usuario = " +  ActionContext.getContext().getSession().get(ConstatnsInterface.SESSION_ID)
				+ " ORDER BY CONCAT( nombre, ' ', apellidos )";
		List<Cliente> resultado = new ArrayList<Cliente>();
		try{
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			rs = st.executeQuery();
			while(rs.next()){
				Cliente cl = new Cliente();
				cl.setId(rs.getInt("ID"));
				cl.setNombre(rs.getString("Nombre"));
				cl.setApellidos(rs.getString("Apellidos"));
				cl.setEmail(rs.getString("email"));
				cl.setTelefono(rs.getString("telefono"));
				resultado.add(cl);
			}
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		return resultado;
	}
	
	
	
	public static Cliente getCliente(Integer id){
		Connection cn = null;
		PreparedStatement st = null;
		ResultSet rs = null;
		String query = "SELECT * FROM fisio_v_clientes WHERE id = ?";
		Cliente cl = new Cliente();
		try{
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			st.setInt(1, id);
			rs = st.executeQuery();
			if(rs.next()){
				
				cl.setId(rs.getInt("id"));
				cl.setNombre(rs.getString("Nombre"));
				cl.setApellidos(rs.getString("Apellidos"));
				cl.setEmail(rs.getString("email"));
				cl.setTelefono(rs.getString("telefono"));
				cl.setDireccion(rs.getString("direccion"));
				cl.setMunicipio(rs.getString("municipio"));
				cl.setCp(rs.getString("codpostal"));
				cl.setProvincia(rs.getString("provincia"));
				cl.setPatologia(rs.getString("patologia"));
				cl.setEvolucion(rs.getString("evolucion"));
			}
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		return cl;
	}
	
	
	public static Integer insertarCliente(Cliente cliente){
		Connection cn = null;
		PreparedStatement st = null;
		Integer id = null;
		try{
			System.out.println(cliente);
			String query = "INSERT INTO fisio_t_clientes (id_usuario, nombre, apellidos, email, telefono, direccion, codpostal, municipio, provincia)"
					+ " VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)";
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			int i = 1;
			st.setInt(i++, (Integer) ActionContext.getContext().getSession().get(ConstatnsInterface.SESSION_ID));
			st.setString(i++, cliente.getNombre());
			st.setString(i++, cliente.getApellidos());
			st.setString(i++, cliente.getEmail());
			st.setString(i++, cliente.getTelefono());
			st.setString(i++, cliente.getDireccion());
			st.setString(i++, cliente.getCp());
			st.setString(i++, cliente.getMunicipio());
			st.setString(i++, cliente.getProvincia());
			st.executeUpdate();
			
			ResultSet rs = st.getGeneratedKeys();
			if(rs.next()){
				id=rs.getInt(1);
			}
			System.out.println(id);
			if(id != null){
				cn.close();
				query = "INSERT INTO fisio_t_patologias (id, id_cliente, patologia, evolucion)"
						+ " VALUES (?, ?, ?, ?)";
				cn = Persistence.getConnection();
				st = cn.prepareStatement(query);
				i = 1;
				st.setString(i++, null);
				st.setInt(i++, id);
				st.setString(i++, cliente.getPatologia());
				st.setString(i++, cliente.getEvolucion());
				st.executeUpdate();
			}
			
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		return id;
	}
	
	public static void guaradarCliente(Cliente cliente){
		Connection cn = null;
		PreparedStatement st = null;
		try{
	
			String query = "UPDATE fisio_t_clientes SET" +
					" nombre = ?," +
					" apellidos = ?," +
					" email = ?," +
					" telefono = ?," +
					" direccion = ?," +
					" codpostal = ?," +
					" municipio = ?," +
					" provincia = ?" +
					" WHERE id = ?";
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			int i = 1;
			st.setString(i++, cliente.getNombre());
			st.setString(i++, cliente.getApellidos());
			st.setString(i++, cliente.getEmail());
			st.setString(i++, cliente.getTelefono());
			st.setString(i++, cliente.getDireccion());
			st.setString(i++, cliente.getCp());
			st.setString(i++, cliente.getMunicipio());
			st.setString(i++, cliente.getProvincia());
			st.setInt(i++, cliente.getId());
			st.executeUpdate();
			
			
			cn.close();
			query = "UPDATE fisio_t_patologias SET "
					+ "patologia = ?, evolucion = ?"
					+ " WHERE id_cliente = ? ";
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			i = 1;
			
			st.setString(i++, cliente.getPatologia());
			st.setString(i++, cliente.getEvolucion());
			st.setInt(i++, cliente.getId());
			st.executeUpdate();
		
			
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		
	}
	
	public static void eliminarCliente(Integer id){
		Connection cn = null;
		PreparedStatement st = null;
		try{
			String query = "DELETE FROM fisio_t_patologias WHERE id_cliente = "+id;
			String query1 = "DELETE FROM fisio_t_ficheros WHERE id_cliente = "+id;
			String query2 = "DELETE FROM fisio_t_citas WHERE id_cliente = "+id;
			String query3 = "DELETE FROM fisio_t_clientes WHERE id = "+id;
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			int i = 1;
			
			st.addBatch(query);
			st.addBatch(query1);
			st.addBatch(query2);
			st.addBatch(query3);
			st.executeBatch();
			
			
			cn.close();
			
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
	}
	
	public static List<Cita> getCitas(Integer idCliente){
		List<Cita> citas = new ArrayList<Cita>();
		Connection cn = null;
		PreparedStatement st = null;
		ResultSet rs = null;
		String query = "SELECT * FROM fisio_v_lista_citas WHERE id_cliente = "+ idCliente;
		
		try{
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			rs = st.executeQuery();
			while(rs.next()){
				Cita cita = new Cita(
						rs.getInt("ID"), 
						rs.getString("descripcion"), 
						rs.getTimestamp("fechaIni"), 
						rs.getTimestamp("fechaFin")
				);
				citas.add(cita);
			}
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		return citas;
	}
}
