package com.rlozano.tfc.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.opensymphony.xwork2.ActionContext;
import com.rlozano.tfc.interfaces.ConstatnsInterface;
import com.rlozano.tfc.models.Cliente;
import com.rlozano.tfc.models.Usuario;
import com.rlozano.tfc.persistence.Persistence;

public class UsuarioDAO {
	public static Integer login(String username, String password){
		Connection cn = null;
		PreparedStatement st = null;
		ResultSet rs = null;
		String query = "SELECT * FROM fisio_t_usuarios WHERE username = ? AND password = ?";
		Integer id = null;
		try{
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			st.setString(1, username);
			st.setString(2, password);
			rs = st.executeQuery();
			if(rs.next()){
				id = rs.getInt("id");
			}
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		return id;
	}
	
	public static List<Usuario> getListado(){
		List<Usuario> resultado = new ArrayList<Usuario>();
		Connection cn = null;
		PreparedStatement st = null;
		ResultSet rs = null;
		String query = "SELECT * FROM fisio_t_usuarios";
		
		try{
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			rs = st.executeQuery();
			while(rs.next()){
				Usuario usu = new Usuario();
				usu.setId( rs.getInt("id"));
				usu.setNombre( rs.getString("nombre"));
				usu.setUsername( rs.getString("username"));
				usu.setPassword( rs.getString("password"));
				usu.setEmail( rs.getString("email"));
				resultado.add(usu);
			}
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		return resultado;
	}
	
	public static Usuario getUsuario(Integer id){
		Usuario usu = null;
		Connection cn = null;
		PreparedStatement st = null;
		ResultSet rs = null;
		String query = "SELECT * FROM fisio_t_usuarios WHERE id = "+id;
		
		try{
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			rs = st.executeQuery();
			if(rs.next()){
				usu = new Usuario();
				usu.setId( rs.getInt("id"));
				usu.setNombre( rs.getString("nombre"));
				usu.setUsername( rs.getString("username"));
				usu.setPassword( rs.getString("password"));
				usu.setEmail( rs.getString("email"));
			}
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		return usu;
	}
	
	public static void eliminarUsuario(Integer id){
		Connection cn = null;
		PreparedStatement st = null;
		try{
			String query  = "DELETE FROM fisio_t_patologias WHERE id_cliente IN (SELECT id FROM fisio_t_clientes WHERE id_usuario = "+id+" )";
			String query2 = "DELETE FROM fisio_t_ficheros WHERE id_cliente IN (SELECT id FROM fisio_t_clientes WHERE id_usuario = "+id+" )";
			String query3 = "DELETE FROM fisio_t_citas WHERE id_cliente IN (SELECT id FROM fisio_t_clientes WHERE id_usuario = "+id+" )";
			String query4 = "DELETE FROM fisio_t_clientes WHERE id_usuario = "+id;
			String query5 = "DELETE FROM fisio_t_usuarios WHERE id = "+id;
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			int i = 1;
			
			st.addBatch(query);
			st.addBatch(query2);
			st.addBatch(query3);
			st.addBatch(query4);
			st.addBatch(query5);
			st.executeBatch();
			
			
			cn.close();
			
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
	}
	
	public static Integer insertarUsuario(Usuario usuario){
		Connection cn = null;
		PreparedStatement st = null;
		Integer id = null;
		try{
			
			String query = "INSERT INTO fisio_t_usuarios (nombre, username, password, email)"
					+ " VALUES (?, ?, ?, ?)";
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			int i = 1;
			st.setString(i++, usuario.getNombre());
			st.setString(i++, usuario.getUsername());
			st.setString(i++, usuario.getPassword());
			st.setString(i++, usuario.getEmail());
			st.executeUpdate();
			
			ResultSet rs = st.getGeneratedKeys();
			if(rs.next()){
				id=rs.getInt(1);
			}
			
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		return id;
	}
	
	public static void guaradarUsuario(Usuario usuario){
		Connection cn = null;
		PreparedStatement st = null;
		try{
	
			String query = "UPDATE fisio_t_usuarios SET" +
					" nombre = ?," +
					" username = ?," +
					" email = ?,";
			if(usuario.getPassword().length() != 0)
				query = query + " password = ?";
			query = query + " WHERE id = ?";
			cn = Persistence.getConnection();
			st = cn.prepareStatement(query);
			int i = 1;
			st.setString(i++, usuario.getNombre());
			st.setString(i++, usuario.getUsername());
			st.setString(i++, usuario.getEmail());
			if(usuario.getPassword().length() != 0) 
				st.setString(i++, usuario.getPassword());
			
			st.setInt(i++, usuario.getId());
			st.executeUpdate();
			
			
			cn.close();		
			
		} catch (Exception e){
		  e.printStackTrace();
		} finally {
			try {
				cn.close();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		
	}
}
